#!/usr/bin/perl
# vp 11.06.2003 14:49

die <<HELP unless @ARGV;
Aufruf: kcc2tap kcc-file [erste Blocknr]
konvertiert (raw) KCC-Dateien ins AF-TAP-Format
beim Z9001 ist die erste Blocknr standardmaessig 0,
beim HC900 allerdings die 1
HELP

$blocknr = $ARGV[1] || 0;

($OUT = $ARGV[0]) =~ s/kcc/tap/i;
die "Fehler: keine KCC-Datei!" if $OUT =~ /$ARGV[0]/i;

open IN, "<$ARGV[0]";
binmode IN;

open OUT, ">$OUT";
binmode OUT;

print "Schreibe $OUT ";

#Filetyp ermitteln
read IN, $block, 11; 
if ($block =~ /^/) {
	#Basic-Dateien beginnen mit Block 1
	$mode = 'BASIC'; $blocknr = 1;
} else { $mode = 'MC' }
seek IN, 0, 0;

#Header schreiben
print OUT 'KC-TAPE by AF. ';

until (eof IN) {
	read IN, $block, 128; 
	# bei MC erhlt der letzte Block die Nr. FF
	if ($mode eq 'MC' and eof (IN)) { $blocknr = 255 }
	print OUT pack("C",$blocknr++);
	print OUT pack("a128", $block);
}
close IN;
close OUT;
